<template>
  <v-container
    fill-height
    fluid
    grid-list-xl
  >
    <v-layout
      justify-center
      wrap
    >
      <v-flex
        md10
      >
        <div>
          <material-card
            color="green"
            title="Subject"
          >
            <template>
              <v-data-table
                :headers="headers"
                :items="course"
                :custom-sort="customSort"
                hide-actions
              >
                <template
                  slot="items"
                  slot-scope="props">
                  <td>
                    <router-link
                      :to="{ path: props.item.code}"
                      append>
                      <b>{{ props.item.code }}</b>
                    </router-link>
                  </td>
                  <td>{{ props.item.name }}</td>
                  <td>{{ props.item.academic_year }}</td>
                </template>
              </v-data-table>
            </template>
          </material-card>
        </div>
      </v-flex>
    </v-layout>
  </v-container>
</template>

<script>
import { mapState, mapGetters } from 'vuex'

export default {
  data () {
    return {
      loading: false,
      headers: [
        {
          text: 'Subject Code',
          value: 'code'
        },
        {
          text: 'Subject name',
          value: 'name'
        },
        {
          text: 'Academic Year',
          value: 'academic_year'
        }
      ]
    }
  },
  computed: {
    ...mapGetters('web3', ['contract', 'student', 'course']),
    ...mapState('app', ['image', 'color'])
  },
  async mounted () {
    await this.$store.dispatch('web3/connectToWeb3')
    await this.$store.dispatch('web3/setContract')
    await this.$store.dispatch('web3/fetchCourse')
  },
  methods: {
    customSort (items, index, isDesc) {
      items.sort((a, b) => {
        if (index === 'academic_year') {
          const aSemeter = a.academic_year.split('/')[0]
          const aYear = a.academic_year.split('/')[1]
          const bSemeter = b.academic_year.split('/')[0]
          const bYear = b.academic_year.split('/')[1]
          if (!isDesc) {
            if (aYear === bYear) {
              if (aSemeter < bSemeter) {
                return -1
              } else {
                return 1
              }
            } else if (aYear < bYear) {
              return -1
            } else {
              return 1
            }
          } else {
            if (bYear === aYear) {
              if (bSemeter < aSemeter) {
                return -1
              } else {
                return 1
              }
            } else if (bYear < aYear) {
              return -1
            } else {
              return 1
            }
          }
        } else {
          if (!isDesc) {
            return a[index] < b[index] ? -1 : 1
          } else {
            return b[index] < a[index] ? -1 : 1
          }
        }
      })
      return items
    }
  }
}
</script>
